Tonyu.klass.define({
  fullName: 'user.Board',
  shortName: 'Board',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Board_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Board_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Board_initialize(o) {
        "use strict";
        var _this=this;
        
        _this.deck=new Tonyu.classes.user.StockDrawPile({owner: _this,x: 300,y: 250,canDrag: false,canTouch: false,isDown: true});
        _this.trash=new Tonyu.classes.user.Stock({owner: _this,x: 300,y: 350,w: 200,canPlace: false,canDragMove: false,logView: true,isDown: false});
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.CanBackRandomSeq',
  shortName: 'CanBackRandomSeq',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CanBackRandomSeq_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_CanBackRandomSeq_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_CanBackRandomSeq_initialize(o) {
        "use strict";
        var _this=this;
        var seed;
        
        seed = o.seed||Tonyu.globals.$Math.floor(Tonyu.globals.$Math.random()*4294967291+1);
        
        _this.history=[];
        _this.maxHistory=o.maxHistory||20;
        _this.reSeed(seed);
      },
      rnd :function _trc_CanBackRandomSeq_rnd(min,max) {
        "use strict";
        var _this=this;
        var n;
        
        if (max!=null) {
          if (max<min) {
            throw Error();
            
            
          }
          n = max-min;
          
          return _this.next()%n+min;
          
        }
        return _this.next()%min;
      },
      next :function _trc_CanBackRandomSeq_next() {
        "use strict";
        var _this=this;
        var t;
        
        t = _this.xors.x^(_this.xors.x<<11);
        
        _this.xors.x=_this.xors.y;
        _this.xors.y=_this.xors.z;
        _this.xors.z=_this.xors.w;
        _this.xors.w=(_this.xors.w^(_this.xors.w>>>19))^(t^(t>>>8));
        return Tonyu.globals.$Math.abs(_this.xors.w);
      },
      fiber$next :function _trc_CanBackRandomSeq_f_next(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var t;
        
        t = _this.xors.x^(_this.xors.x<<11);
        
        _this.xors.x=_this.xors.y;
        _this.xors.y=_this.xors.z;
        _this.xors.z=_this.xors.w;
        _this.xors.w=(_this.xors.w^(_this.xors.w>>>19))^(t^(t>>>8));
        _thread.retVal=Tonyu.globals.$Math.abs(_this.xors.w);return;
        
        
        _thread.retVal=_this;return;
      },
      reSeed :function _trc_CanBackRandomSeq_reSeed(s) {
        "use strict";
        var _this=this;
        var seed;
        
        seed = s||Tonyu.globals.$Math.floor(Tonyu.globals.$Math.random()*4294967291+1);
        
        if (seed==0) {
          seed+=1;
        }
        _this.xors={x: 123456789,y: 362436069,z: 521288629,w: seed};
      },
      fiber$reSeed :function _trc_CanBackRandomSeq_f_reSeed(_thread,s) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var seed;
        
        seed = s||Tonyu.globals.$Math.floor(Tonyu.globals.$Math.random()*4294967291+1);
        
        if (seed==0) {
          seed+=1;
        }
        _this.xors={x: 123456789,y: 362436069,z: 521288629,w: seed};
        
        _thread.retVal=_this;return;
      },
      getSeq :function _trc_CanBackRandomSeq_getSeq() {
        "use strict";
        var _this=this;
        
        return {x: _this.xors.x,y: _this.xors.y,z: _this.xors.z,w: _this.xors.w};
      },
      fiber$getSeq :function _trc_CanBackRandomSeq_f_getSeq(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal={x: _this.xors.x,y: _this.xors.y,z: _this.xors.z,w: _this.xors.w};return;
        
        
        _thread.retVal=_this;return;
      },
      setSeq :function _trc_CanBackRandomSeq_setSeq(seq) {
        "use strict";
        var _this=this;
        
        _this.xors={x: seq.x,y: seq.y,z: seq.z,w: seq.w};
      },
      fiber$setSeq :function _trc_CanBackRandomSeq_f_setSeq(_thread,seq) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.xors={x: seq.x,y: seq.y,z: seq.z,w: seq.w};
        
        _thread.retVal=_this;return;
      },
      saveSeq :function _trc_CanBackRandomSeq_saveSeq() {
        "use strict";
        var _this=this;
        
        if (_this.history.length>_this.maxHistory) {
          _this.history.shift();
          
        }
        _this.history.push(_this.getSeq());
      },
      fiber$saveSeq :function _trc_CanBackRandomSeq_f_saveSeq(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.history.length>_this.maxHistory) {
          _this.history.shift();
          
        }
        _this.history.push(_this.getSeq());
        
        _thread.retVal=_this;return;
      },
      backSeq :function _trc_CanBackRandomSeq_backSeq() {
        "use strict";
        var _this=this;
        var seq;
        
        if (_this.history.length<1) {
          return false;
          
        }
        seq = _this.history.pop();
        
        _this.setSeq(seq);
      },
      fiber$backSeq :function _trc_CanBackRandomSeq_f_backSeq(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var seq;
        
        if (_this.history.length<1) {
          _thread.retVal=false;return;
          
          
        }
        seq = _this.history.pop();
        
        _this.setSeq(seq);
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"rnd":{"nowait":true},"next":{"nowait":false},"reSeed":{"nowait":false},"getSeq":{"nowait":false},"setSeq":{"nowait":false},"saveSeq":{"nowait":false},"backSeq":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Card',
  shortName: 'Card',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Card_main() {
        "use strict";
        var _this=this;
        
        _this.touching=false;
        _this.on("touch",Tonyu.bindFunc(_this,_this.drag));
        while (1) {
          Tonyu.checkLoop();
          if (! _this.touching) {
            _this.updateSlideMoveTo(_this.tx,_this.ty);
            
          }
          _this.updateSlideRotationTo(_this.trotation);
          _this.update();
          
        }
      },
      fiber$main :function _trc_Card_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.touching=false;
        _this.on("touch",Tonyu.bindFunc(_this,_this.drag));
        
        _thread.enter(function _trc_Card_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(1)) { __pc=6     ; break; }
              if (!(! _this.touching)) { __pc=3     ; break; }
              _this.fiber$updateSlideMoveTo(_thread, _this.tx, _this.ty);
              __pc=2;return;
            case 2:
              
            case 3     :
              
              _this.fiber$updateSlideRotationTo(_thread, _this.trotation);
              __pc=4;return;
            case 4:
              
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=1;break;
            case 6     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_Card_initialize(o) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [o]);
        _this.id=o.id;
        _this.stock=o.stock;
        _this.index=o.index;
        _this.suit=o.suit;
        _this.rank=o.rank||1;
        if (_this.suit==4) {
          _this.rank=0;
        }
        _this.isDown=null;
        _this.x=0;
        _this.y=0;
        _this.tx=0;
        _this.ty=0;
        _this.trotation=0;
        _this.rotation=0;
        _this.angle=0;
        _this.zOrder=0;
        _this.scaleX=2;
        _this.rePat();
        _this.t=0;
        _this.finger=null;
        _this.on("moveStock",(function anonymous_492(stock) {
          
          _this.trotation=_this.stock.rotation;
          _this.t=0;
          _this.rePat();
          _this.dragStop();
        }));
      },
      getSuitPat :function _trc_Card_getSuitPat(suit) {
        "use strict";
        var _this=this;
        
        if (suit==0) {
          return Tonyu.globals.$pat_cardsMedium_tilemap_+30;
        }
        if (suit==1) {
          return Tonyu.globals.$pat_cardsMedium_tilemap_+15;
        }
        if (suit==2) {
          return Tonyu.globals.$pat_cardsMedium_tilemap_;
        }
        if (suit==3) {
          return Tonyu.globals.$pat_cardsMedium_tilemap_+45;
        }
        if (suit==4) {
          return Tonyu.globals.$pat_cardsMedium_tilemap_+44;
        }
      },
      fiber$getSuitPat :function _trc_Card_f_getSuitPat(_thread,suit) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (suit==0) {
          _thread.retVal=Tonyu.globals.$pat_cardsMedium_tilemap_+30;return;
          
        }
        if (suit==1) {
          _thread.retVal=Tonyu.globals.$pat_cardsMedium_tilemap_+15;return;
          
        }
        if (suit==2) {
          _thread.retVal=Tonyu.globals.$pat_cardsMedium_tilemap_;return;
          
        }
        if (suit==3) {
          _thread.retVal=Tonyu.globals.$pat_cardsMedium_tilemap_+45;return;
          
        }
        if (suit==4) {
          _thread.retVal=Tonyu.globals.$pat_cardsMedium_tilemap_+44;return;
          
        }
        
        _thread.retVal=_this;return;
      },
      rePat :function _trc_Card_rePat() {
        "use strict";
        var _this=this;
        
        if (_this.isDown||(_this.stock&&_this.stock.isDown)) {
          _this.p=Tonyu.globals.$pat_cardsMedium_tilemap_+29;
          
        } else {
          if (_this.suit==4) {
            _this.p=_this.getSuitPat(_this.suit);
          } else {
            _this.p=_this.getSuitPat(_this.suit)+_this.rank-1;
          }
          
        }
      },
      fiber$rePat :function _trc_Card_f_rePat(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.isDown||(_this.stock&&_this.stock.isDown)) {
          _this.p=Tonyu.globals.$pat_cardsMedium_tilemap_+29;
          
        } else {
          if (_this.suit==4) {
            _this.p=_this.getSuitPat(_this.suit);
          } else {
            _this.p=_this.getSuitPat(_this.suit)+_this.rank-1;
          }
          
        }
        
        _thread.retVal=_this;return;
      },
      setDown :function _trc_Card_setDown(bool) {
        "use strict";
        var _this=this;
        
        _this.isDown=bool;
        _this.rePat();
      },
      fiber$setDown :function _trc_Card_f_setDown(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.isDown=bool;
        _this.rePat();
        
        _thread.retVal=_this;return;
      },
      moveStockTo :function _trc_Card_moveStockTo(stock) {
        "use strict";
        var _this=this;
        
        _this.stock.sendCardTo(_this,stock);
      },
      fiber$moveStockTo :function _trc_Card_f_moveStockTo(_thread,stock) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.stock.sendCardTo(_this,stock);
        
        _thread.retVal=_this;return;
      },
      getSlideAmount :function _trc_Card_getSlideAmount(orig,target,ratio) {
        "use strict";
        var _this=this;
        var diff;
        
        ratio=ratio<=1?ratio:1;
        diff = target-orig;
        
        if (_this.abs(diff)>0.1) {
          return diff*ratio;
          
        } else {
          return diff;
          
        }
      },
      fiber$getSlideAmount :function _trc_Card_f_getSlideAmount(_thread,orig,target,ratio) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var diff;
        
        ratio=ratio<=1?ratio:1;
        diff = target-orig;
        
        if (_this.abs(diff)>0.1) {
          _thread.retVal=diff*ratio;return;
          
          
        } else {
          _thread.retVal=diff;return;
          
          
        }
        
        _thread.retVal=_this;return;
      },
      updateSlideMoveTo :function _trc_Card_updateSlideMoveTo(tx,ty,trotation) {
        "use strict";
        var _this=this;
        
        _this.x+=_this.getSlideAmount(_this.x,tx,0.1);
        _this.y+=_this.getSlideAmount(_this.y,ty,0.1);
      },
      fiber$updateSlideMoveTo :function _trc_Card_f_updateSlideMoveTo(_thread,tx,ty,trotation) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.x+=_this.getSlideAmount(_this.x,tx,0.1);
        _this.y+=_this.getSlideAmount(_this.y,ty,0.1);
        
        _thread.retVal=_this;return;
      },
      updateSlideRotationTo :function _trc_Card_updateSlideRotationTo(trotation) {
        "use strict";
        var _this=this;
        
        _this.rotation+=_this.getSlideAmount(_this.rotation,trotation,0.2)||0;
      },
      fiber$updateSlideRotationTo :function _trc_Card_f_updateSlideRotationTo(_thread,trotation) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.rotation+=_this.getSlideAmount(_this.rotation,trotation,0.2)||0;
        
        _thread.retVal=_this;return;
      },
      drag :function _trc_Card_drag(touchEvent) {
        "use strict";
        var _this=this;
        var f;
        
        if (! _this.stock.canDrag) {
          return _this;
        }
        f = touchEvent.finger;
        
        _this.finger=[];
        _this.touching=true;
        _this.trotation=0;
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardSlide3);
        _this.finger.push(f.on("move",(function anonymous_2313(moveEvent) {
          
          _this.x=moveEvent.x;
          _this.y=moveEvent.y;
        })));
        _this.finger.push(f.on("end",(function anonymous_2415(endEvent) {
          
          _this.touching=false;
          _this.trotation=_this.stock.rotation;
          _this.stock.sendEvent("cardTouched",{card: _this,t: touchEvent});
          _this.finger=null;
        })));
      },
      fiber$drag :function _trc_Card_f_drag(_thread,touchEvent) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var f;
        
        if (! _this.stock.canDrag) {
          _thread.retVal=_this;return;
          
        }
        f = touchEvent.finger;
        
        _this.finger=[];
        _this.touching=true;
        _this.trotation=0;
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardSlide3);
        _this.finger.push(f.on("move",(function anonymous_2313(moveEvent) {
          
          _this.x=moveEvent.x;
          _this.y=moveEvent.y;
        })));
        _this.finger.push(f.on("end",(function anonymous_2415(endEvent) {
          
          _this.touching=false;
          _this.trotation=_this.stock.rotation;
          _this.stock.sendEvent("cardTouched",{card: _this,t: touchEvent});
          _this.finger=null;
        })));
        
        _thread.retVal=_this;return;
      },
      dragStop :function _trc_Card_dragStop() {
        "use strict";
        var _this=this;
        var _it_14764;
        
        _this.touching=false;
        if (_this.finger) {
          _it_14764=Tonyu.iterator(_this.finger,1);
          while(_it_14764.next()) {
            _this.e=_it_14764[0];
            
            _this.e.remove();
            
          }
          
        }
      },
      fiber$dragStop :function _trc_Card_f_dragStop(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_14764;
        
        _this.touching=false;
        if (_this.finger) {
          _it_14764=Tonyu.iterator(_this.finger,1);
          while(_it_14764.next()) {
            _this.e=_it_14764[0];
            
            _this.e.remove();
            
          }
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"getSuitPat":{"nowait":false},"rePat":{"nowait":false},"setDown":{"nowait":false},"moveStockTo":{"nowait":false},"getSlideAmount":{"nowait":false},"updateSlideMoveTo":{"nowait":false},"updateSlideRotationTo":{"nowait":false},"drag":{"nowait":false},"dragStop":{"nowait":false}},"fields":{"touching":{},"tx":{},"ty":{},"trotation":{},"suit":{},"e":{}}}
});
Tonyu.klass.define({
  fullName: 'user.CardFactory',
  shortName: 'CardFactory',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CardFactory_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_CardFactory_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_CardFactory_initialize(o) {
        "use strict";
        var _this=this;
        
        _this.idCnt=0;
      },
      newCard :function _trc_CardFactory_newCard(o) {
        "use strict";
        var _this=this;
        var card;
        
        o.id=_this.idCnt;
        card = new Tonyu.classes.user.Card(o);
        
        _this.idCnt++;
        return card;
      },
      fiber$newCard :function _trc_CardFactory_f_newCard(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var card;
        
        o.id=_this.idCnt;
        card = new Tonyu.classes.user.Card(o);
        
        _this.idCnt++;
        _thread.retVal=card;return;
        
        
        _thread.retVal=_this;return;
      },
      newCardTo :function _trc_CardFactory_newCardTo(stock,o) {
        "use strict";
        var _this=this;
        var card;
        
        card = _this.newCard(o);
        
        stock.push(card);
        return stock;
      },
      fiber$newCardTo :function _trc_CardFactory_f_newCardTo(_thread,stock,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var card;
        
        card = _this.newCard(o);
        
        stock.push(card);
        _thread.retVal=stock;return;
        
        
        _thread.retVal=_this;return;
      },
      newCardPackTo :function _trc_CardFactory_newCardPackTo(stock) {
        "use strict";
        var _this=this;
        var suit;
        var rank;
        var card;
        
        suit = 0;
        for (; suit<=3 ; suit++) {
          Tonyu.checkLoop();
          {
            rank = 1;
            for (; rank<=13 ; rank++) {
              Tonyu.checkLoop();
              {
                card = _this.newCard({suit: suit,rank: rank});
                
                stock.push(card);
              }
            }
          }
        }
        return stock;
      },
      fiber$newCardPackTo :function _trc_CardFactory_f_newCardPackTo(_thread,stock) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var suit;
        var rank;
        var card;
        
        suit = 0;
        for (; suit<=3 ; suit++) {
          Tonyu.checkLoop();
          {
            rank = 1;
            for (; rank<=13 ; rank++) {
              Tonyu.checkLoop();
              {
                card = _this.newCard({suit: suit,rank: rank});
                
                stock.push(card);
              }
            }
          }
        }
        _thread.retVal=stock;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"newCard":{"nowait":false},"newCardTo":{"nowait":false},"newCardPackTo":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.CardPlaceArea',
  shortName: 'CardPlaceArea',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CardPlaceArea_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_CardPlaceArea_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_CardPlaceArea_initialize(o) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [o]);
        _this.w=o.w||300;
        _this.h=o.h||38;
        _this.rotation=o.rotation!=null?o.rotation:0;
        _this.parent=_this.lifeKeeper;
        _this.p=- 1;
        _this.color="";
      },
      draw :function _trc_CardPlaceArea_draw(ctx) {
        "use strict";
        var _this=this;
        var width;
        var height;
        var x;
        var y;
        var textSize;
        var text;
        var textObj;
        
        width = _this.lerp(_this.w,_this.h,_this.abs(_this.sin(_this.rotation)));
        
        height = _this.lerp(_this.w,_this.h,_this.abs(_this.cos(_this.rotation)));
        
        x = _this.x-width/2;
        
        y = _this.y-height/2;
        
        ctx.strokeStyle="#fff";
        ctx.lineWidth=1;
        ctx.strokeRect(x,y,width,height);
        if (_this.color) {
          ctx.fillStyle=_this.color;
          ctx.fillRect(x,y,width,height);
          
        }
        if (_this.text) {
          ctx.textBaseline="middle";
          ctx.lineWidth=2;
          textSize = _this.textSize?_this.textSize:16;
          
          ctx.font=textSize+"px sans-serif";
          text = _this.text;
          
          textObj = ctx.measureText(text);
          
          x = _this.x-textObj.width/2;
          
          y = _this.y;
          
          ctx.strokeStyle="black";
          ctx.strokeText(text,x,y);
          ctx.fillStyle="white";
          ctx.fillText(text,x,y);
          
        }
      },
      getCrashRect :function _trc_CardPlaceArea_getCrashRect() {
        "use strict";
        var _this=this;
        var width;
        var height;
        
        width = _this.lerp(_this.w,_this.h,_this.abs(_this.sin(_this.rotation)));
        
        height = _this.lerp(_this.w,_this.h,_this.abs(_this.cos(_this.rotation)));
        
        return {x: _this.x,y: _this.y,width: width,height: height};
      },
      lerp :function _trc_CardPlaceArea_lerp(a,b,t) {
        "use strict";
        var _this=this;
        
        return a+(b-a)*t;
      },
      fiber$lerp :function _trc_CardPlaceArea_f_lerp(_thread,a,b,t) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=a+(b-a)*t;return;
        
        
        _thread.retVal=_this;return;
      },
      isCrash :function _trc_CardPlaceArea_isCrash(x,y) {
        "use strict";
        var _this=this;
        var o;
        
        o = _this.getCrashRect();
        
        if (x>=o.x-o.width/2&&x<=o.x+o.width/2&&y>=o.y-o.height/2&&y<=o.y+o.height/2) {
          return true;
          
        }
        return false;
      },
      fiber$isCrash :function _trc_CardPlaceArea_f_isCrash(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var o;
        
        o = _this.getCrashRect();
        
        if (x>=o.x-o.width/2&&x<=o.x+o.width/2&&y>=o.y-o.height/2&&y<=o.y+o.height/2) {
          _thread.retVal=true;return;
          
          
        }
        _thread.retVal=false;return;
        
        
        _thread.retVal=_this;return;
      },
      setStatusPull :function _trc_CardPlaceArea_setStatusPull(bool) {
        "use strict";
        var _this=this;
        
        if (bool) {
          _this.color="rgba(255,165,0,0.5)";
          
        } else {
          _this.color="";
          
        }
      },
      fiber$setStatusPull :function _trc_CardPlaceArea_f_setStatusPull(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (bool) {
          _this.color="rgba(255,165,0,0.5)";
          
        } else {
          _this.color="";
          
        }
        
        _thread.retVal=_this;return;
      },
      setStatusNowTurn :function _trc_CardPlaceArea_setStatusNowTurn(bool) {
        "use strict";
        var _this=this;
        
        if (bool) {
          _this.color="rgba(0,255,0,0.5)";
          
        } else {
          _this.color="";
          
        }
      },
      fiber$setStatusNowTurn :function _trc_CardPlaceArea_f_setStatusNowTurn(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (bool) {
          _this.color="rgba(0,255,0,0.5)";
          
        } else {
          _this.color="";
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"draw":{"nowait":true},"getCrashRect":{"nowait":true},"lerp":{"nowait":false},"isCrash":{"nowait":false},"setStatusPull":{"nowait":false},"setStatusNowTurn":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.CardStockMod',
  shortName: 'CardStockMod',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CardStockMod_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_CardStockMod_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      sendCardTo :function _trc_CardStockMod_sendCardTo(card,stock) {
        "use strict";
        var _this=this;
        var index;
        var i;
        
        index = card.index;
        
        if (card==_this.cards[index]) {
          _this.cards.splice(index,1);
          i = index;
          for (; i<_this.cards.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.cards[i].index=i;
            }
          }
          stock.push(card);
          
        } else {
          _this.print("err! sendCardTo "+card.id+" "+_this.cards[card.index].id+"");
          
        }
        _this.sendEvent("cardSent",card);
      },
      fiber$sendCardTo :function _trc_CardStockMod_f_sendCardTo(_thread,card,stock) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var index;
        var i;
        
        index = card.index;
        
        if (card==_this.cards[index]) {
          _this.cards.splice(index,1);
          i = index;
          for (; i<_this.cards.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.cards[i].index=i;
            }
          }
          stock.push(card);
          
        } else {
          _this.print("err! sendCardTo "+card.id+" "+_this.cards[card.index].id+"");
          
        }
        _this.sendEvent("cardSent",card);
        
        _thread.retVal=_this;return;
      },
      sendRndOne :function _trc_CardStockMod_sendRndOne(hand) {
        "use strict";
        var _this=this;
        
        if (_this.cards.length>0) {
          _this.cards[Tonyu.globals.$myRandom.rnd(0,_this.cards.length)].moveStockTo(hand);
          
        }
      },
      fiber$sendRndOne :function _trc_CardStockMod_f_sendRndOne(_thread,hand) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.cards.length>0) {
          _this.cards[Tonyu.globals.$myRandom.rnd(0,_this.cards.length)].moveStockTo(hand);
          
        }
        
        _thread.retVal=_this;return;
      },
      push :function _trc_CardStockMod_push(card) {
        "use strict";
        var _this=this;
        
        card.stock=_this;
        card.index=_this.cards.length;
        _this.cards.push(card);
        _this.sendEvent("cardPushed",card);
        card.sendEvent("moveStock",_this);
        return _this;
      },
      fiber$push :function _trc_CardStockMod_f_push(_thread,card) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        card.stock=_this;
        card.index=_this.cards.length;
        _this.cards.push(card);
        _this.sendEvent("cardPushed",card);
        card.sendEvent("moveStock",_this);
        _thread.retVal=_this;return;
        
        
        _thread.retVal=_this;return;
      },
      shuffle :function _trc_CardStockMod_shuffle() {
        "use strict";
        var _this=this;
        var i;
        var j;
        
        i = _this.cards.length-1;
        for (; i>=0 ; i--) {
          Tonyu.checkLoop();
          {
            j = Tonyu.globals.$myRandom.rnd(0,i+1);
            
            _this.cardSwap(i,j);
          }
        }
        _this.sendEvent("cardSwapped");
        return _this;
      },
      fiber$shuffle :function _trc_CardStockMod_f_shuffle(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        var j;
        
        i = _this.cards.length-1;
        for (; i>=0 ; i--) {
          Tonyu.checkLoop();
          {
            j = Tonyu.globals.$myRandom.rnd(0,i+1);
            
            _this.cardSwap(i,j);
          }
        }
        _this.sendEvent("cardSwapped");
        _thread.retVal=_this;return;
        
        
        _thread.retVal=_this;return;
      },
      cardSwap :function _trc_CardStockMod_cardSwap(i,j) {
        "use strict";
        var _this=this;
        var cards;
        var k;
        
        cards = _this.cards;
        
        k = cards[i];
        
        cards[i]=cards[j];
        cards[j]=k;
        cards[i].index=i;
        cards[j].index=j;
      },
      fiber$cardSwap :function _trc_CardStockMod_f_cardSwap(_thread,i,j) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var cards;
        var k;
        
        cards = _this.cards;
        
        k = cards[i];
        
        cards[i]=cards[j];
        cards[j]=k;
        cards[i].index=i;
        cards[j].index=j;
        
        _thread.retVal=_this;return;
      },
      sort :function _trc_CardStockMod_sort() {
        "use strict";
        var _this=this;
        var i;
        
        _this.cards.sort((function anonymous_1160(f,s) {
          
          if (s.rank==null) {
            return - 1;
          }
          if (f.rank==null) {
            return 1;
          }
          return f.rank-s.rank;
        }));
        i = 0;
        for (; i<_this.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.cards[i].index=i;
          }
        }
        _this.repos();
      },
      fiber$sort :function _trc_CardStockMod_f_sort(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        _this.cards.sort((function anonymous_1160(f,s) {
          
          if (s.rank==null) {
            return - 1;
          }
          if (f.rank==null) {
            return 1;
          }
          return f.rank-s.rank;
        }));
        i = 0;
        for (; i<_this.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.cards[i].index=i;
          }
        }
        _this.repos();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"sendCardTo":{"nowait":false},"sendRndOne":{"nowait":false},"push":{"nowait":false},"shuffle":{"nowait":false},"cardSwap":{"nowait":false},"sort":{"nowait":false}},"fields":{"cards":{},"repos":{}}}
});
Tonyu.klass.define({
  fullName: 'user.GameMaster',
  shortName: 'GameMaster',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameMaster_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_GameMaster_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_GameMaster_initialize(o) {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$GameMaster=_this;
        _this.board=new Tonyu.classes.user.Board();
        _this.deck=_this.board.deck;
        _this.trash=_this.board.trash;
        _this.players=[];
        _this.firstPlayer=null;
        _this.turnPlayer=null;
        _this.spectMode=false;
        _this.turnCnt=0;
        _this.gameState=0;
        _this.loop=new Tonyu.classes.user.GameMasterUpdater();
        Tonyu.globals.$CardFactory.newCardPackTo(_this.deck);
        Tonyu.globals.$CardFactory.newCardTo(_this.deck,{suit: 4,rank: 0});
        _this.gameInit();
        _this.gameReady();
      },
      gameInit :function _trc_GameMaster_gameInit() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$CardFactory.newCardPackTo(_this.deck);
        _this.players=[];
        _this.players.push(new Tonyu.classes.user.Player({name: "ユーザー",y: 500}));
        _this.players.push(new Tonyu.classes.user.Player({name: "CPU1",x: 100,y: 300,rotation: - 90}));
        _this.players.push(new Tonyu.classes.user.Player({name: "CPU2",y: 100}));
        _this.players.push(new Tonyu.classes.user.Player({name: "CPU3",x: 500,y: 300,rotation: 90}));
        _this.deck.shuffle();
      },
      fiber$gameInit :function _trc_GameMaster_f_gameInit(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$CardFactory.newCardPackTo(_this.deck);
        _this.players=[];
        _this.players.push(new Tonyu.classes.user.Player({name: "ユーザー",y: 500}));
        _this.players.push(new Tonyu.classes.user.Player({name: "CPU1",x: 100,y: 300,rotation: - 90}));
        _this.players.push(new Tonyu.classes.user.Player({name: "CPU2",y: 100}));
        _this.players.push(new Tonyu.classes.user.Player({name: "CPU3",x: 500,y: 300,rotation: 90}));
        _this.deck.shuffle();
        
        _thread.retVal=_this;return;
      },
      gameRetry :function _trc_GameMaster_gameRetry() {
        "use strict";
        var _this=this;
        var self;
        
        self = Tonyu.globals.$GameMaster;
        
        if (self.gameState==0||self.gameState==1) {
          return _this;
        }
        if (Tonyu.globals.$GameResult) {
          Tonyu.globals.$GameResult.die();
        }
        self.gameState=0;
        self.loop.parallel("gameRetryLoop",Tonyu.globals.$GameMaster.gameReady);
      },
      fiber$gameRetry :function _trc_GameMaster_f_gameRetry(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var self;
        
        self = Tonyu.globals.$GameMaster;
        
        if (self.gameState==0||self.gameState==1) {
          _thread.retVal=_this;return;
          
        }
        if (Tonyu.globals.$GameResult) {
          Tonyu.globals.$GameResult.die();
        }
        self.gameState=0;
        self.loop.parallel("gameRetryLoop",Tonyu.globals.$GameMaster.gameReady);
        
        _thread.retVal=_this;return;
      },
      gameReady :function _trc_GameMaster_gameReady() {
        "use strict";
        var _this=this;
        var self;
        var i;
        
        self = Tonyu.globals.$GameMaster;
        
        self.players[0].setFirstUser(false);
        if (Tonyu.globals.$GameResult) {
          Tonyu.globals.$GameResult.die();
        }
        Tonyu.globals.$GameResult=new Tonyu.classes.user.GameResult();
        i = 0;
        for (; i<self.players.length ; i++) {
          Tonyu.checkLoop();
          {
            self.players[i].agari=false;
          }
        }
        self.setSpectMode(false);
        self.gameState=1;
        self.loop.parallel("gameReadyLoop",Tonyu.globals.$GameMaster.gameStart);
      },
      fiber$gameReady :function _trc_GameMaster_f_gameReady(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var self;
        var i;
        
        self = Tonyu.globals.$GameMaster;
        
        self.players[0].setFirstUser(false);
        if (Tonyu.globals.$GameResult) {
          Tonyu.globals.$GameResult.die();
        }
        Tonyu.globals.$GameResult=new Tonyu.classes.user.GameResult();
        i = 0;
        for (; i<self.players.length ; i++) {
          Tonyu.checkLoop();
          {
            self.players[i].agari=false;
          }
        }
        self.setSpectMode(false);
        self.gameState=1;
        self.loop.parallel("gameReadyLoop",Tonyu.globals.$GameMaster.gameStart);
        
        _thread.retVal=_this;return;
      },
      gameStart :function _trc_GameMaster_gameStart() {
        "use strict";
        var _this=this;
        var self;
        var i;
        
        self = Tonyu.globals.$GameMaster;
        
        self.gameState=2;
        i = 0;
        for (; i<self.players.length ; i++) {
          Tonyu.checkLoop();
          {
            self.players[i].cardMatch();
          }
        }
        self.players[0].setFirstUser(true);
        self.players[0].sort();
        self.turnPlayerIdx=0;
        self.turnPlayer=self.players[self.turnPlayerIdx];
        self.turnCnt=0;
        self.nextTurn();
      },
      fiber$gameStart :function _trc_GameMaster_f_gameStart(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var self;
        var i;
        
        self = Tonyu.globals.$GameMaster;
        
        self.gameState=2;
        i = 0;
        for (; i<self.players.length ; i++) {
          Tonyu.checkLoop();
          {
            self.players[i].cardMatch();
          }
        }
        self.players[0].setFirstUser(true);
        self.players[0].sort();
        self.turnPlayerIdx=0;
        self.turnPlayer=self.players[self.turnPlayerIdx];
        self.turnCnt=0;
        self.nextTurn();
        
        _thread.retVal=_this;return;
      },
      nextTurn :function _trc_GameMaster_nextTurn() {
        "use strict";
        var _this=this;
        var self;
        var i;
        
        self = Tonyu.globals.$GameMaster;
        
        self.turnPlayer.setNowTurn(false);
        if (self.gameState==0) {
          return _this;
          
        }
        self.turnPlayer=null;
        i = 1;
        for (; i<self.players.length ; i++) {
          Tonyu.checkLoop();
          {
            self.turnPlayerIdx++;
            if (self.turnPlayerIdx>=self.players.length) {
              self.turnPlayerIdx=0;
            }
            if (self.players[self.turnPlayerIdx].alive) {
              self.turnPlayer=self.players[self.turnPlayerIdx];
              break;
              
              
            }
          }
        }
        if (! self.turnPlayer) {
          return self.gameEnd();
          
        }
        self.turnCnt++;
        self.turnPlayer.setNowTurn(true);
        self.targetPlayer=self.nowTargetPlayer();
        if (! self.targetPlayer) {
          _this.print("targetNone gameEnd");
          return self.gameEnd();
          
        }
        self.loop.parallel("turnLoop",self.turnPullEnd);
      },
      fiber$nextTurn :function _trc_GameMaster_f_nextTurn(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var self;
        var i;
        
        self = Tonyu.globals.$GameMaster;
        
        self.turnPlayer.setNowTurn(false);
        if (self.gameState==0) {
          _thread.retVal=_this;return;
          
          
        }
        self.turnPlayer=null;
        i = 1;
        for (; i<self.players.length ; i++) {
          Tonyu.checkLoop();
          {
            self.turnPlayerIdx++;
            if (self.turnPlayerIdx>=self.players.length) {
              self.turnPlayerIdx=0;
            }
            if (self.players[self.turnPlayerIdx].alive) {
              self.turnPlayer=self.players[self.turnPlayerIdx];
              break;
              
              
            }
          }
        }
        if (! self.turnPlayer) {
          _thread.retVal=self.gameEnd();return;
          
          
        }
        self.turnCnt++;
        self.turnPlayer.setNowTurn(true);
        self.targetPlayer=self.nowTargetPlayer();
        if (! self.targetPlayer) {
          _this.print("targetNone gameEnd");
          _thread.retVal=self.gameEnd();return;
          
          
        }
        self.loop.parallel("turnLoop",self.turnPullEnd);
        
        _thread.retVal=_this;return;
      },
      turnPullEnd :function _trc_GameMaster_turnPullEnd() {
        "use strict";
        var _this=this;
        var self;
        
        self = Tonyu.globals.$GameMaster;
        
        if (self.gameState==0) {
          self.turnPlayer.setNowTurn(false);
          return _this;
          
        }
        self.loop.parallel("turnEnd",self.turnEnd);
      },
      fiber$turnPullEnd :function _trc_GameMaster_f_turnPullEnd(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var self;
        
        self = Tonyu.globals.$GameMaster;
        
        if (self.gameState==0) {
          self.turnPlayer.setNowTurn(false);
          _thread.retVal=_this;return;
          
          
        }
        self.loop.parallel("turnEnd",self.turnEnd);
        
        _thread.retVal=_this;return;
      },
      turnEnd :function _trc_GameMaster_turnEnd() {
        "use strict";
        var _this=this;
        var self;
        
        self = Tonyu.globals.$GameMaster;
        
        if (! self.firstPlayer.alive&&! self.spectMode) {
          self.setSpectMode(true);
          
        }
        self.nextTurn();
      },
      fiber$turnEnd :function _trc_GameMaster_f_turnEnd(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var self;
        
        self = Tonyu.globals.$GameMaster;
        
        if (! self.firstPlayer.alive&&! self.spectMode) {
          self.setSpectMode(true);
          
        }
        self.nextTurn();
        
        _thread.retVal=_this;return;
      },
      nowTurnPlayer :function _trc_GameMaster_nowTurnPlayer(turn) {
        "use strict";
        var _this=this;
        
      },
      fiber$nowTurnPlayer :function _trc_GameMaster_f_nowTurnPlayer(_thread,turn) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      nowTargetPlayer :function _trc_GameMaster_nowTargetPlayer() {
        "use strict";
        var _this=this;
        var targetPlayer;
        var i;
        var n;
        
        targetPlayer = null;
        
        i = 1;
        for (; i<_this.players.length ; i++) {
          Tonyu.checkLoop();
          {
            n = _this.turnPlayerIdx+i;
            
            if (n>=_this.players.length) {
              n-=_this.players.length;
            }
            if (_this.players[n].alive) {
              targetPlayer=_this.players[n];
              
            }
          }
        }
        return targetPlayer;
      },
      fiber$nowTargetPlayer :function _trc_GameMaster_f_nowTargetPlayer(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var targetPlayer;
        var i;
        var n;
        
        targetPlayer = null;
        
        i = 1;
        for (; i<_this.players.length ; i++) {
          Tonyu.checkLoop();
          {
            n = _this.turnPlayerIdx+i;
            
            if (n>=_this.players.length) {
              n-=_this.players.length;
            }
            if (_this.players[n].alive) {
              targetPlayer=_this.players[n];
              
            }
          }
        }
        _thread.retVal=targetPlayer;return;
        
        
        _thread.retVal=_this;return;
      },
      setSpectMode :function _trc_GameMaster_setSpectMode(bool) {
        "use strict";
        var _this=this;
        var i;
        
        if (_this.spectMode==bool) {
          return _this;
        }
        if (bool) {
          i = 1;
          for (; i<_this.players.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.players[i].hand.setDown(false);
            }
          }
          
        } else {
          i = 1;
          for (; i<_this.players.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.players[i].hand.setDown(true);
            }
          }
          
        }
        _this.spectMode=bool;
      },
      fiber$setSpectMode :function _trc_GameMaster_f_setSpectMode(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        if (_this.spectMode==bool) {
          _thread.retVal=_this;return;
          
        }
        if (bool) {
          i = 1;
          for (; i<_this.players.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.players[i].hand.setDown(false);
            }
          }
          
        } else {
          i = 1;
          for (; i<_this.players.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.players[i].hand.setDown(true);
            }
          }
          
        }
        _this.spectMode=bool;
        
        _thread.retVal=_this;return;
      },
      gameEnd :function _trc_GameMaster_gameEnd() {
        "use strict";
        var _this=this;
        
        new Tonyu.classes.user.GameOver();
      },
      fiber$gameEnd :function _trc_GameMaster_f_gameEnd(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        new Tonyu.classes.user.GameOver();
        
        _thread.retVal=_this;return;
      },
      deckPush :function _trc_GameMaster_deckPush(card) {
        "use strict";
        var _this=this;
        
        _this.deck.push(card);
      },
      fiber$deckPush :function _trc_GameMaster_f_deckPush(_thread,card) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.deck.push(card);
        
        _thread.retVal=_this;return;
      },
      timeout :function _trc_GameMaster_timeout(t,callback) {
        "use strict";
        var _this=this;
        
        _this.loop.parallel("timeout",t,callback);
      },
      fiber$timeout :function _trc_GameMaster_f_timeout(_thread,t,callback) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.loop.parallel("timeout",t,callback);
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"gameInit":{"nowait":false},"gameRetry":{"nowait":false},"gameReady":{"nowait":false},"gameStart":{"nowait":false},"nextTurn":{"nowait":false},"turnPullEnd":{"nowait":false},"turnEnd":{"nowait":false},"nowTurnPlayer":{"nowait":false},"nowTargetPlayer":{"nowait":false},"setSpectMode":{"nowait":false},"gameEnd":{"nowait":false},"deckPush":{"nowait":false},"timeout":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.GameMasterUpdater',
  shortName: 'GameMasterUpdater',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameMasterUpdater_main() {
        "use strict";
        var _this=this;
        
        while (1) {
          Tonyu.checkLoop();
          if (_this.getkey("r")==1) {
            Tonyu.globals.$GameMaster.gameRetry();
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_GameMasterUpdater_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_GameMasterUpdater_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(1)) { __pc=3     ; break; }
              if (_this.getkey("r")==1) {
                Tonyu.globals.$GameMaster.gameRetry();
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      setLoop :function _trc_GameMasterUpdater_setLoop(fn) {
        "use strict";
        var _this=this;
        
        _this.fns=[fn];
        _this.print(_this.fns.length);
      },
      fiber$setLoop :function _trc_GameMasterUpdater_f_setLoop(_thread,fn) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.fns=[fn];
        _this.print(_this.fns.length);
        
        _thread.retVal=_this;return;
      },
      gameRetryLoop :function _trc_GameMasterUpdater_gameRetryLoop(callback) {
        "use strict";
        var _this=this;
        var cards;
        var _it_14803;
        
        cards = _this.all(Tonyu.classes.user.Card);
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardShuffle);
        _it_14803=Tonyu.iterator(cards,1);
        while(_it_14803.next()) {
          _this.card=_it_14803[0];
          
          _this.card.dragStop();
          _this.card.moveStockTo(Tonyu.globals.$GameMaster.deck);
          _this.update();
          
        }
        Tonyu.globals.$GameMaster.deck.shuffle();
        _this.updateEx(30);
        callback();
      },
      fiber$gameRetryLoop :function _trc_GameMasterUpdater_f_gameRetryLoop(_thread,callback) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var cards;
        var _it_14803;
        
        cards = _this.all(Tonyu.classes.user.Card);
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardShuffle);
        
        _thread.enter(function _trc_GameMasterUpdater_ent_gameRetryLoop(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _it_14803=Tonyu.iterator(cards,1);
            case 1:
              if (!(_it_14803.next())) { __pc=3     ; break; }
              _this.card=_it_14803[0];
              
              _this.card.dragStop();
              _this.card.moveStockTo(Tonyu.globals.$GameMaster.deck);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              Tonyu.globals.$GameMaster.deck.shuffle();
              _this.fiber$updateEx(_thread, 30);
              __pc=4;return;
            case 4:
              
              callback();
              _thread.exit(_this);return;
            }
          }
        });
      },
      gameReadyLoop :function _trc_GameMasterUpdater_gameReadyLoop(callback) {
        "use strict";
        var _this=this;
        var i;
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardShuffle);
        while (Tonyu.globals.$GameMaster.deck.cards.length) {
          Tonyu.checkLoop();
          i = 0;
          for (; i<4 ; i++) {
            Tonyu.checkLoop();
            {
              Tonyu.globals.$GameMaster.deck.drawTo(Tonyu.globals.$GameMaster.players[i].hand);
              _this.update();
            }
          }
          
        }
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardOpen);
        _this.updateEx(30);
        callback();
      },
      fiber$gameReadyLoop :function _trc_GameMasterUpdater_f_gameReadyLoop(_thread,callback) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardShuffle);
        
        _thread.enter(function _trc_GameMasterUpdater_ent_gameReadyLoop(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(Tonyu.globals.$GameMaster.deck.cards.length)) { __pc=6     ; break; }
              i = 0;
              
            case 2:
              if (!(i<4)) { __pc=5     ; break; }
              Tonyu.globals.$GameMaster.deck.drawTo(Tonyu.globals.$GameMaster.players[i].hand);
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
            case 4     :
              i++;
              __pc=2;break;
            case 5     :
              
              __pc=1;break;
            case 6     :
              
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardOpen);
              _this.fiber$updateEx(_thread, 30);
              __pc=7;return;
            case 7:
              
              callback();
              _thread.exit(_this);return;
            }
          }
        });
      },
      gameLoop :function _trc_GameMasterUpdater_gameLoop(callback) {
        "use strict";
        var _this=this;
        var master;
        var turnEnd;
        
        master = Tonyu.globals.$GameMaster;
        
        while (master.firstPlayer.hand.cards.length) {
          Tonyu.checkLoop();
          turnEnd = false;
          
          master.nextTurn();
          while (! master.turnEnd) {
            Tonyu.checkLoop();
            _this.update();
            
          }
          master.firstPlayer.hand.on("cardPushed",(function anonymous_1190(card) {
            
          }));
          _this.update();
          
        }
        callback();
      },
      fiber$gameLoop :function _trc_GameMasterUpdater_f_gameLoop(_thread,callback) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var master;
        var turnEnd;
        
        master = Tonyu.globals.$GameMaster;
        
        
        _thread.enter(function _trc_GameMasterUpdater_ent_gameLoop(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(master.firstPlayer.hand.cards.length)) { __pc=6     ; break; }
              turnEnd = false;
              
              master.nextTurn();
            case 2:
              if (!(! master.turnEnd)) { __pc=4     ; break; }
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              __pc=2;break;
            case 4     :
              
              master.firstPlayer.hand.on("cardPushed",(function anonymous_1190(card) {
                
              }));
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=1;break;
            case 6     :
              
              callback();
              _thread.exit(_this);return;
            }
          }
        });
      },
      turnLoop :function _trc_GameMasterUpdater_turnLoop(callback) {
        "use strict";
        var _this=this;
        var master;
        var turnEnd;
        var targetPlayer;
        var r;
        
        master = Tonyu.globals.$GameMaster;
        
        turnEnd = 0;
        
        targetPlayer = master.targetPlayer;
        
        r = master.turnPlayer.hand.on("cardPushed",(function anonymous_1439(card) {
          
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardSlide);
          turnEnd=1;
          return callback();
        }));
        
        if (master.turnPlayer==master.firstPlayer) {
          targetPlayer.hand.setPullMode(true);
          targetPlayer.hand.allowMoveStocks=master.turnPlayer.hand;
          while (! turnEnd&&master.gameState!=0) {
            Tonyu.checkLoop();
            _this.update();
            
          }
          targetPlayer.hand.setPullMode(false);
          
        } else {
          targetPlayer.hand.sendRndOne(master.turnPlayer.hand);
          while (! turnEnd&&master.gameState!=0) {
            Tonyu.checkLoop();
            _this.update();
            
          }
          
        }
        r.remove();
        if (master.gameState==0) {
          callback();
        }
      },
      fiber$turnLoop :function _trc_GameMasterUpdater_f_turnLoop(_thread,callback) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var master;
        var turnEnd;
        var targetPlayer;
        var r;
        
        master = Tonyu.globals.$GameMaster;
        
        turnEnd = 0;
        
        targetPlayer = master.targetPlayer;
        
        r = master.turnPlayer.hand.on("cardPushed",(function anonymous_1439(card) {
          
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardSlide);
          turnEnd=1;
          return callback();
        }));
        
        
        _thread.enter(function _trc_GameMasterUpdater_ent_turnLoop(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(master.turnPlayer==master.firstPlayer)) { __pc=4     ; break; }
              targetPlayer.hand.setPullMode(true);
              targetPlayer.hand.allowMoveStocks=master.turnPlayer.hand;
            case 1:
              if (!(! turnEnd&&master.gameState!=0)) { __pc=3     ; break; }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              targetPlayer.hand.setPullMode(false);
              __pc=8     ;break;
            case 4     :
              targetPlayer.hand.sendRndOne(master.turnPlayer.hand);
            case 5:
              if (!(! turnEnd&&master.gameState!=0)) { __pc=7     ; break; }
              _this.fiber$update(_thread);
              __pc=6;return;
            case 6:
              
              __pc=5;break;
            case 7     :
              
            case 8     :
              
              r.remove();
              if (master.gameState==0) {
                callback();
              }
              _thread.exit(_this);return;
            }
          }
        });
      },
      turnEnd :function _trc_GameMasterUpdater_turnEnd(callback) {
        "use strict";
        var _this=this;
        var master;
        
        master = Tonyu.globals.$GameMaster;
        
        _this.updateEx(30);
        master.turnPlayer.cardMatch();
        if (master.turnPlayer==master.firstPlayer) {
          master.turnPlayer.sort();
          
        } else {
          master.turnPlayer.shuffle();
          
        }
        callback();
      },
      fiber$turnEnd :function _trc_GameMasterUpdater_f_turnEnd(_thread,callback) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var master;
        
        master = Tonyu.globals.$GameMaster;
        
        
        _thread.enter(function _trc_GameMasterUpdater_ent_turnEnd(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$updateEx(_thread, 30);
              __pc=1;return;
            case 1:
              
              master.turnPlayer.cardMatch();
              if (master.turnPlayer==master.firstPlayer) {
                master.turnPlayer.sort();
                
              } else {
                master.turnPlayer.shuffle();
                
              }
              callback();
              _thread.exit(_this);return;
            }
          }
        });
      },
      timeout :function _trc_GameMasterUpdater_timeout(t,callback) {
        "use strict";
        var _this=this;
        
        while (t) {
          Tonyu.checkLoop();
          _this.update();
          t--;
          
        }
        callback();
      },
      fiber$timeout :function _trc_GameMasterUpdater_f_timeout(_thread,t,callback) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_GameMasterUpdater_ent_timeout(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(t)) { __pc=3     ; break; }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              t--;
              __pc=1;break;
            case 3     :
              
              callback();
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"setLoop":{"nowait":false},"gameRetryLoop":{"nowait":false},"gameReadyLoop":{"nowait":false},"gameLoop":{"nowait":false},"turnLoop":{"nowait":false},"turnEnd":{"nowait":false},"timeout":{"nowait":false}},"fields":{"card":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Hand',
  shortName: 'Hand',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [Tonyu.classes.user.CardStockMod],
  methods: function (__superClass) {
    return {
      main :function _trc_Hand_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Hand_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Hand_initialize(o) {
        "use strict";
        var _this=this;
        
        _this.owner=o.owner;
        _this.cards=o.cards||[];
        _this.parent=o.parent||null;
        _this.cx=o.cx!=null?o.cx:Tonyu.globals.$screenWidth/2;
        _this.cy=o.cy!=null?o.cy:Tonyu.globals.$screenHeight/2;
        _this.w=o.w||400;
        _this.h=o.h||38;
        _this.rotation=o.rotation||0;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.resize(600,600);
        Tonyu.globals.$Screen.setBGColor("#176");
        Tonyu.globals.$myRandom=new Tonyu.classes.user.CanBackRandomSeq({maxHistory: 5});
        Tonyu.globals.$CardFactory=new Tonyu.classes.user.CardFactory();
        Tonyu.globals.$GameMaster=new Tonyu.classes.user.GameMaster();
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.resize(600,600);
        Tonyu.globals.$Screen.setBGColor("#176");
        Tonyu.globals.$myRandom=new Tonyu.classes.user.CanBackRandomSeq({maxHistory: 5});
        Tonyu.globals.$CardFactory=new Tonyu.classes.user.CardFactory();
        Tonyu.globals.$GameMaster=new Tonyu.classes.user.GameMaster();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Player',
  shortName: 'Player',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Player_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Player_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Player_initialize(o) {
        "use strict";
        var _this=this;
        var y;
        var x;
        var rotation;
        
        y = o.y||300;
        
        x = o.x||300;
        
        _this.y=y;
        _this.x=x;
        rotation = o.rotation||0;
        
        _this.hand=new Tonyu.classes.user.Stock({owner: _this,y: y,x: x,rotation: rotation,canDrag: false});
        _this.hand.on("cardPushed",(function anonymous_218(card) {
          var self;
          
          self = _this;
          
        }));
        _this.hand.on("cardSent",(function anonymous_414(card) {
          
          if (Tonyu.globals.$GameMaster.gameState>1&&_this.hand.cards.length==0&&! _this.agari) {
            Tonyu.globals.$GameResult.finish(_this);
            _this.agari=true;
            
          }
        }));
        _this.isUserPlayer=false;
        _this.name=o.name;
        _this.agari=false;
      },
      cardMatch :function _trc_Player_cardMatch() {
        "use strict";
        var _this=this;
        var self;
        var i;
        var card;
        var pairCard;
        
        self = _this;
        
        i = 0;
        for (; i<_this.hand.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            card = _this.hand.cards[i];
            
            pairCard = self.sameRankPair(card);
            
            if (pairCard) {
              self.sendTrash(card);
              self.sendTrash(pairCard);
              i--;
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardPlace);
              
            }
          }
        }
      },
      fiber$cardMatch :function _trc_Player_f_cardMatch(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var self;
        var i;
        var card;
        var pairCard;
        
        self = _this;
        
        i = 0;
        for (; i<_this.hand.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            card = _this.hand.cards[i];
            
            pairCard = self.sameRankPair(card);
            
            if (pairCard) {
              self.sendTrash(card);
              self.sendTrash(pairCard);
              i--;
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_cardPlace);
              
            }
          }
        }
        
        _thread.retVal=_this;return;
      },
      __getter__alive :function _trc_Player___getter__alive() {
        "use strict";
        var _this=this;
        
        return _this.hand.cards.length>0;
      },
      sort :function _trc_Player_sort() {
        "use strict";
        var _this=this;
        
        _this.hand.sort();
      },
      fiber$sort :function _trc_Player_f_sort(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.hand.sort();
        
        _thread.retVal=_this;return;
      },
      shuffle :function _trc_Player_shuffle() {
        "use strict";
        var _this=this;
        
        _this.hand.shuffle();
      },
      fiber$shuffle :function _trc_Player_f_shuffle(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.hand.shuffle();
        
        _thread.retVal=_this;return;
      },
      setFirstUser :function _trc_Player_setFirstUser(bool) {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$GameMaster.firstPlayer=_this;
        _this.isUserPlayer=bool;
        _this.hand.setDown(! bool);
        _this.hand.canDragMove=false;
        _this.hand.canDrag=true;
      },
      fiber$setFirstUser :function _trc_Player_f_setFirstUser(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$GameMaster.firstPlayer=_this;
        _this.isUserPlayer=bool;
        _this.hand.setDown(! bool);
        _this.hand.canDragMove=false;
        _this.hand.canDrag=true;
        
        _thread.retVal=_this;return;
      },
      setNowTurn :function _trc_Player_setNowTurn(bool) {
        "use strict";
        var _this=this;
        
        _this.hand.cardPlaceArea.setStatusNowTurn(bool);
      },
      fiber$setNowTurn :function _trc_Player_f_setNowTurn(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.hand.cardPlaceArea.setStatusNowTurn(bool);
        
        _thread.retVal=_this;return;
      },
      sendCardTo :function _trc_Player_sendCardTo(card,stock) {
        "use strict";
        var _this=this;
        
        return _this.hand.sendCardTo(card,stock);
      },
      fiber$sendCardTo :function _trc_Player_f_sendCardTo(_thread,card,stock) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.hand.sendCardTo(card,stock);return;
        
        
        _thread.retVal=_this;return;
      },
      sendTrash :function _trc_Player_sendTrash(card) {
        "use strict";
        var _this=this;
        
        card.isDown=false;
        return _this.hand.sendCardTo(card,Tonyu.globals.$GameMaster.trash);
      },
      fiber$sendTrash :function _trc_Player_f_sendTrash(_thread,card) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        card.isDown=false;
        _thread.retVal=_this.hand.sendCardTo(card,Tonyu.globals.$GameMaster.trash);return;
        
        
        _thread.retVal=_this;return;
      },
      sameRankPair :function _trc_Player_sameRankPair(card) {
        "use strict";
        var _this=this;
        var pairCard;
        var i;
        
        pairCard = null;
        
        i = 0;
        for (; i<_this.hand.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            if (card.rank==_this.hand.cards[i].rank&&card.id!=_this.hand.cards[i].id) {
              pairCard=_this.hand.cards[i];
              
            }
          }
        }
        return pairCard;
      },
      fiber$sameRankPair :function _trc_Player_f_sameRankPair(_thread,card) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var pairCard;
        var i;
        
        pairCard = null;
        
        i = 0;
        for (; i<_this.hand.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            if (card.rank==_this.hand.cards[i].rank&&card.id!=_this.hand.cards[i].id) {
              pairCard=_this.hand.cards[i];
              
            }
          }
        }
        _thread.retVal=pairCard;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"cardMatch":{"nowait":false},"__getter__alive":{"nowait":true},"sort":{"nowait":false},"shuffle":{"nowait":false},"setFirstUser":{"nowait":false},"setNowTurn":{"nowait":false},"sendCardTo":{"nowait":false},"sendTrash":{"nowait":false},"sameRankPair":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Stock',
  shortName: 'Stock',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [Tonyu.classes.user.CardStockMod],
  methods: function (__superClass) {
    return {
      main :function _trc_Stock_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Stock_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Stock_initialize(o) {
        "use strict";
        var _this=this;
        
        _this.owner=o.owner;
        _this.cards=o.cards||[];
        _this.parent=o.parent||null;
        _this.x=o.x!=null?o.x:Tonyu.globals.$screenWidth/2;
        _this.y=o.y!=null?o.y:Tonyu.globals.$screenHeight/2;
        _this.w=o.w||400;
        _this.h=o.h||38;
        _this.rotation=o.rotation||0;
        _this.zOrder=o.zOrder||100;
        _this.canPlace=o.canPlace!=null?o.canPlace:true;
        _this.cardPlaceArea=new Tonyu.classes.user.CardPlaceArea({lifeKeeper: _this,x: _this.x,y: _this.y,w: _this.w,h: _this.h,zOrder: _this.zOrder,rotation: _this.rotation});
        _this.isDown=o.isDown!=null?o.isDown:true;
        _this.canDrag=o.canDrag!=null?o.canDrag:true;
        _this.canDragMove=o.canDragMove!=null?o.canDragMove:true;
        _this.allowMoveStocks=null;
        _this.logView=o.logView!=null?o.logView:false;
        _this.on("cardPushed",(function anonymous_830(card) {
          
          _this.repos();
        }));
        _this.on("cardSent",(function anonymous_950(card) {
          
          _this.repos();
        }));
        _this.on("cardTouched",(function anonymous_1010(o) {
          var card;
          var e;
          var stock;
          
          if (! _this.canDragMove) {
            return _this;
          }
          card = o.card;
          
          e = card.crashTo(Tonyu.classes.user.CardPlaceArea);
          
          if (e&&e!=_this.cardPlaceArea) {
            stock = e.parent;
            
            if (! _this.chkAllowStocks(stock,_this.allowMoveStocks)) {
              return _this;
            }
            if (! stock.canPlace) {
              return _this;
            }
            o.card.moveStockTo(stock);
            
          }
        }));
        _this.on("cardSwapped",(function anonymous_1396(o) {
          
          _this.repos();
        }));
      },
      chkAllowStocks :function _trc_Stock_chkAllowStocks(target,stocks) {
        "use strict";
        var _this=this;
        var ok;
        var _it_14835;
        
        if (! stocks||stocks.length==0) {
          return true;
        }
        if (target==stocks) {
          return true;
        }
        ok = false;
        
        _it_14835=Tonyu.iterator(stocks,1);
        while(_it_14835.next()) {
          _this.st=_it_14835[0];
          
          if (_this.st==target) {
            ok=true;
            break;
            
            
          }
          
        }
        return ok;
      },
      fiber$chkAllowStocks :function _trc_Stock_f_chkAllowStocks(_thread,target,stocks) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ok;
        var _it_14835;
        
        if (! stocks||stocks.length==0) {
          _thread.retVal=true;return;
          
        }
        if (target==stocks) {
          _thread.retVal=true;return;
          
        }
        ok = false;
        
        _it_14835=Tonyu.iterator(stocks,1);
        while(_it_14835.next()) {
          _this.st=_it_14835[0];
          
          if (_this.st==target) {
            ok=true;
            break;
            
            
          }
          
        }
        _thread.retVal=ok;return;
        
        
        _thread.retVal=_this;return;
      },
      setDown :function _trc_Stock_setDown(bool) {
        "use strict";
        var _this=this;
        var i;
        
        _this.isDown=bool;
        i = 0;
        for (; i<_this.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.cards[i].rePat();
          }
        }
      },
      fiber$setDown :function _trc_Stock_f_setDown(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        _this.isDown=bool;
        i = 0;
        for (; i<_this.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.cards[i].rePat();
          }
        }
        
        _thread.retVal=_this;return;
      },
      setPullMode :function _trc_Stock_setPullMode(bool) {
        "use strict";
        var _this=this;
        
        _this.canDrag=bool;
        _this.cardPlaceArea.setStatusPull(bool);
      },
      fiber$setPullMode :function _trc_Stock_f_setPullMode(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.canDrag=bool;
        _this.cardPlaceArea.setStatusPull(bool);
        
        _thread.retVal=_this;return;
      },
      repos :function _trc_Stock_repos() {
        "use strict";
        var _this=this;
        var sx;
        var wt;
        var i;
        
        sx = _this.x-_this.w/2+_this.w/(_this.cards.length+1);
        
        wt = _this.w/2-_this.w/(_this.cards.length+1);
        
        if (_this.logView) {
          i = 0;
          for (; i<_this.cards.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.cards[i].tx=sx+_this.w-Tonyu.globals.$Math.log10((_this.cards.length-i)/_this.cards.length*9+1)*_this.w;
              _this.cards[i].ty=_this.y;
              _this.cards[i].zOrder=_this.zOrder-i+_this.cards.length;
            }
          }
          
        } else {
          i = 0;
          for (; i<_this.cards.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.cards[i].tx=_this.x-(wt-_this.w/(_this.cards.length+1)*i)*_this.cos(_this.rotation);
              _this.cards[i].ty=_this.y-(wt-_this.w/(_this.cards.length+1)*i)*_this.sin(_this.rotation);
              ;
              
              _this.cards[i].zOrder=_this.zOrder-i+_this.cards.length;
            }
          }
          
        }
      },
      fiber$repos :function _trc_Stock_f_repos(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var sx;
        var wt;
        var i;
        
        sx = _this.x-_this.w/2+_this.w/(_this.cards.length+1);
        
        wt = _this.w/2-_this.w/(_this.cards.length+1);
        
        if (_this.logView) {
          i = 0;
          for (; i<_this.cards.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.cards[i].tx=sx+_this.w-Tonyu.globals.$Math.log10((_this.cards.length-i)/_this.cards.length*9+1)*_this.w;
              _this.cards[i].ty=_this.y;
              _this.cards[i].zOrder=_this.zOrder-i+_this.cards.length;
            }
          }
          
        } else {
          i = 0;
          for (; i<_this.cards.length ; i++) {
            Tonyu.checkLoop();
            {
              _this.cards[i].tx=_this.x-(wt-_this.w/(_this.cards.length+1)*i)*_this.cos(_this.rotation);
              _this.cards[i].ty=_this.y-(wt-_this.w/(_this.cards.length+1)*i)*_this.sin(_this.rotation);
              ;
              
              _this.cards[i].zOrder=_this.zOrder-i+_this.cards.length;
            }
          }
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"chkAllowStocks":{"nowait":false},"setDown":{"nowait":false},"setPullMode":{"nowait":false},"repos":{"nowait":false}},"fields":{"st":{}}}
});
Tonyu.klass.define({
  fullName: 'user.StockDrawPile',
  shortName: 'StockDrawPile',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [Tonyu.classes.user.CardStockMod],
  methods: function (__superClass) {
    return {
      main :function _trc_StockDrawPile_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_StockDrawPile_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_StockDrawPile_initialize(o) {
        "use strict";
        var _this=this;
        
        _this.owner=o.owner;
        _this.cards=o.cards||[];
        _this.parent=o.parent||null;
        _this.x=o.x!=null?o.x:Tonyu.globals.$screenWidth/2;
        _this.y=o.y!=null?o.y:Tonyu.globals.$screenHeight/2;
        _this.w=o.w||28;
        _this.h=o.h||38;
        _this.rotation=o.rotation||0;
        _this.zOrder=o.zOrder||200;
        _this.cardPlaceArea=new Tonyu.classes.user.CardPlaceArea({lifeKeeper: _this,x: _this.x,y: _this.y,w: _this.w,h: _this.h,zOrder: _this.zOrder});
        _this.isDown=o.isDown!=null?o.isDown:true;
        _this.canDrag=o.canDrag!=null?o.canDrag:true;
        _this.canTouch=o.canTouch!=null?o.canTouch:false;
        _this.on("cardPushed",(function anonymous_650(card) {
          
          _this.repos();
        }));
        _this.on("cardSent",(function anonymous_763(card) {
          
        }));
        _this.on("cardSwapped",(function anonymous_825() {
          
          _this.repos();
        }));
        _this.cardPlaceArea.on("touch",(function anonymous_894(touchEvent) {
          var f;
          
          if (! _this.canTouch) {
            return _this;
          }
          f = touchEvent.finger;
          
          f.on("end",(function anonymous_1050(endEvent) {
            
            if (_this.cardPlaceArea.isCrash(endEvent.x,endEvent.y)) {
              _this.drawTo(Tonyu.globals.$GameMaster.players[0].hand);
              
            }
          }));
        }));
        _this.on("cardTouched",(function anonymous_1314(o) {
          
        }));
      },
      __getter__isCanDraw :function _trc_StockDrawPile___getter__isCanDraw() {
        "use strict";
        var _this=this;
        
        return _this.cards.length>0;
      },
      drawTo :function _trc_StockDrawPile_drawTo(hand) {
        "use strict";
        var _this=this;
        
        if (_this.cards.length>0) {
          _this.cards[0].moveStockTo(hand);
          
        }
      },
      fiber$drawTo :function _trc_StockDrawPile_f_drawTo(_thread,hand) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.cards.length>0) {
          _this.cards[0].moveStockTo(hand);
          
        }
        
        _thread.retVal=_this;return;
      },
      repos :function _trc_StockDrawPile_repos() {
        "use strict";
        var _this=this;
        var i;
        
        i = 0;
        for (; i<_this.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.cards[i].tx=_this.x+_this.rnd(9)-4;
            _this.cards[i].ty=_this.y+_this.rnd(9)-4;
            _this.cards[i].zOrder=_this.zOrder+i;
          }
        }
      },
      fiber$repos :function _trc_StockDrawPile_f_repos(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        i = 0;
        for (; i<_this.cards.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.cards[i].tx=_this.x+_this.rnd(9)-4;
            _this.cards[i].ty=_this.y+_this.rnd(9)-4;
            _this.cards[i].zOrder=_this.zOrder+i;
          }
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"__getter__isCanDraw":{"nowait":true},"drawTo":{"nowait":false},"repos":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.GameOver',
  shortName: 'GameOver',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameOver_main() {
        "use strict";
        var _this=this;
        
        new Tonyu.classes.kernel.Button({top: 0,lifeKeeper: _this,text: "Retry",onClick: (function anonymous_54() {
          
          Tonyu.globals.$GameMaster.gameRetry();
          _this.die();
        })});
      },
      fiber$main :function _trc_GameOver_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        new Tonyu.classes.kernel.Button({top: 0,lifeKeeper: _this,text: "Retry",onClick: (function anonymous_54() {
          
          Tonyu.globals.$GameMaster.gameRetry();
          _this.die();
        })});
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.GameResult',
  shortName: 'GameResult',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameResult_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_GameResult_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      finish :function _trc_GameResult_finish(player) {
        "use strict";
        var _this=this;
        
        new Tonyu.classes.kernel.Label({x: player.x,y: player.y,text: player.name+"上がり ターン"+Tonyu.globals.$GameMaster.turnCnt,lifeKeeper: _this});
      },
      fiber$finish :function _trc_GameResult_f_finish(_thread,player) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        new Tonyu.classes.kernel.Label({x: player.x,y: player.y,text: player.name+"上がり ターン"+Tonyu.globals.$GameMaster.turnCnt,lifeKeeper: _this});
        
        _thread.retVal=_this;return;
      },
      text :function _trc_GameResult_text(o) {
        "use strict";
        var _this=this;
        
      },
      fiber$text :function _trc_GameResult_f_text(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"finish":{"nowait":false},"text":{"nowait":false}},"fields":{}}
});

//# sourceMappingURL=concat.js.map